unit MainScreen;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DXDraws, DXSprite, colli3DX, ExtCtrls, StdCtrls, JvExControls,
  JvAnimatedImage, JvGIFCtrl, jpeg, Buttons, solutil, MPlayer, FileCtrl;

type
  TForm2 = class(TForm)
    Image1: TImage;
    Image2: TImage;
    Image3: TImage;
    Image4: TImage;
    Score1: TLabel;
    Score2: TLabel;
    Score3: TLabel;
    Score4: TLabel;
    Question: TLabel;
    answer1: TLabel;
    answer2: TLabel;
    answer3: TLabel;
    answer4: TLabel;
    Image5: TImage;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    SolUtil1: TSolUtil;
    media: TMediaPlayer;
    answerimg1: TImage;
    answerimg2: TImage;
    answerimg3: TImage;
    answerimg4: TImage;
    sel1: TImage;
    sel2: TImage;
    sel3: TImage;
    sel4: TImage;
    time1: TLabel;
    time2: TLabel;
    time3: TLabel;
    time4: TLabel;
    BitBtn4: TBitBtn;
    bgm: TMediaPlayer;
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure QuestionDblClick(Sender: TObject);
  private
    { Private declarations }
  public
    procedure initialize;

    { Public declarations }
  end;

var
  Form2: TForm2;
  f: textfile;
  correctanswer: integer;
  theendofgame:boolean;

implementation

uses Controller, endofgame;

{$R *.dfm}

procedure readquestion;
var dummy: string;
begin
  form2.answer1.show;
  form2.answer2.show;
  form2.answer3.show;
  form2.answer4.show;

  if not eof(f) then
  begin
    ReadLN(f, dummy);
    form2.question.caption := dummy;

    readln(f, dummy);
    if dummy[1] = '*' then
    begin
      correctanswer := 1;
      form2.answer1.caption := copy(dummy, 2, length(dummy) - 1);
      form2.answer1.Show;
    end
    else
      if dummy[1] = '-' then
      begin
        form2.answer1.hide;
      end
      else
        form2.answer1.caption := dummy;

    readln(f, dummy);
    if dummy[1] = '*' then
    begin
      correctanswer := 2;
      form2.answer2.caption := copy(dummy, 2, length(dummy) - 1);
      form2.answer2.Show;
    end
    else
      if dummy[1] = '-' then
      begin
        form2.answer2.hide;
      end
      else
        form2.answer2.caption := dummy;

    readln(f, dummy);
    if dummy[1] = '*' then
    begin
      correctanswer := 3;
      form2.answer3.caption := copy(dummy, 2, length(dummy) - 1);
      form2.answer3.Show;
    end
    else
      if dummy[1] = '-' then
      begin
        form2.answer3.hide;
      end

      else
        form2.answer3.caption := dummy;

    readln(f, dummy);
    if dummy[1] = '*' then
    begin
      correctanswer := 4;
      form2.answer4.caption := copy(dummy, 2, length(dummy) - 1);
      form2.answer4.Show;
    end
    else
      if dummy[1] = '-' then
      begin
        form2.answer4.hide;
      end

      else
        form2.answer4.caption := dummy;

  end
  else
  begin
  theendofgame := true;
  end;



end;

procedure TForm2.BitBtn1Click(Sender: TObject);
begin
  theendofgame := false;


  AssignFile(f, solutil1.startdir + '\questions.txt');
  Reset(f);
  score1.caption := '0';
  score2.caption := '0';
  score3.caption := '0';
  score4.Caption := '0';
  form1.BuzzerReset;
   //form1.seltimer.enabled := true;
  form1.SelTimer.enabled := false;
  form1.UnflashButton(flashchannel);
  maxbuzztime := 60000;
  maxafterbuzztime := 100;
  numplayers := 4;

  media.filename := solutil1.startdir + '\sounds\newgame.wav';
  media.open;
  media.Rewind;
  media.play;


end;




procedure TForm2.BitBtn2Click(Sender: TObject);
var quickbuzz, selected, abuzztime, amaxbuzztime: integer;
  ok: boolean;
begin

  answerimg1.hide;
  answerimg2.hide;
  answerimg3.hide;
  answerimg4.hide;

  sel1.hide;
  sel2.hide;
  sel3.hide;
  sel4.Hide;

  time1.hide;
  time2.hide;
  time3.hide;
  time4.Hide;


  ReadQuestion;

  if theendofgame then form3.show;
  

  afterbuzztime := 0;
  form1.buzzerreset;
  okaytopress := true;
  afterbuzzon := false;
  Buzztime := 0;
  form1.BuzzerTimer.Enabled := true;
  form1.ButtonsPressedT.Enabled := true;

  while form1.BuzzerTimer.enabled do
    application.processmessages;


  quickbuzz := form1.QuickestBuzzer;

  if quickbuzz = 1 then sel1.Show;
    if quickbuzz = 2 then sel2.Show;
      if quickbuzz = 3 then sel3.Show;
        if quickbuzz = 4 then sel4.Show;




   if buzzctrl[1].Pressed then
   begin
     time1.Caption := '+'+inttostr(buzzctrl[1].milliseconds-buzzctrl[quickbuzz].MilliSeconds);
     if quickbuzz <> 1 then time1.show;
   end;

   if buzzctrl[2].Pressed then
   begin
     time2.Caption := '+'+inttostr(buzzctrl[2].milliseconds-buzzctrl[quickbuzz].MilliSeconds);
         if quickbuzz <> 2 then  time2.show;
   end;

      if buzzctrl[3].Pressed then
   begin
     time3.Caption := '+'+inttostr(buzzctrl[3].milliseconds-buzzctrl[quickbuzz].MilliSeconds);
         if quickbuzz <> 3 then  time3.show;
   end;

      if buzzctrl[4].Pressed then
   begin
     time4.Caption := '+'+inttostr(buzzctrl[4].milliseconds-buzzctrl[quickbuzz].MilliSeconds);
         if quickbuzz <> 4 then  time4.show;
   end;




  form1.SelTimer.enabled := true;
  ok := false;
  form1.flashButton(quickbuzz);

  form1.Buttonspressedt.Enabled := false;
  form1.buzzertimer.enabled := false;
  selected := -1;
  okaytopress := true;
  while not ok do
  begin
    if buzzctrl[quickbuzz].Blue then begin ok := true; selected := 1; end;
    if buzzctrl[quickbuzz].Orange then begin ok := true; selected := 2; end;
    if buzzctrl[quickbuzz].Green then begin ok := true; selected := 3; end;
    if buzzctrl[quickbuzz].Yellow then begin ok := true; selected := 4; end;

    application.processmessages;

    inc(abuzztime);
  end;



  form1.seltimer.Enabled := false;
  form1.unflashbutton(quickbuzz);
  okaytopress := false;


  if selected = correctanswer then
  begin
    media.FileName := solutil1.startdir + '\sounds\correct.wav';
    media.open;
    media.Rewind;
    media.play;
    if quickbuzz = 1 then
    begin
      score1.Caption := inttostr(strtoint(score1.caption) + 5);

    end;
    if quickbuzz = 2 then
    begin
      score2.Caption := inttostr(strtoint(score2.caption) + 5);


    end;
    if quickbuzz = 3 then
    begin
      score3.Caption := inttostr(strtoint(score3.caption) + 5);


    end;
    if quickbuzz = 4 then
    begin
      score4.Caption := inttostr(strtoint(score4.caption) + 5);


    end;

    if correctanswer = 1 then
    begin
      answerimg1.Picture.LoadFromFile(solutil1.startdir + '\images\right.bmp');
      answerimg1.Show;
    end;

    if correctanswer = 2 then
    begin

      answerimg2.Picture.LoadFromFile(solutil1.startdir + '\images\right.bmp');
      answerimg2.Show;
    end;
    if correctanswer = 3 then
    begin

      answerimg3.Picture.LoadFromFile(solutil1.startdir + '\images\right.bmp');
      answerimg3.Show;
    end;
    if correctanswer = 4 then
    begin

      answerimg4.Picture.LoadFromFile(solutil1.startdir + '\images\right.bmp');
      answerimg4.Show;
    end;

  end
  else
  begin
    media.FileName := solutil1.startdir + '\sounds\incorrect.wav';
    media.open;
    media.Rewind;
    media.play;

    if quickbuzz = 1 then
    begin
      score1.Caption := inttostr(strtoint(score1.caption) - 2);

    end;
    if quickbuzz = 2 then
    begin
      score2.Caption := inttostr(strtoint(score2.caption) - 2);


    end;
    if quickbuzz = 3 then
    begin
      score3.Caption := inttostr(strtoint(score3.caption) - 2);


    end;
    if quickbuzz = 4 then
    begin
      score4.Caption := inttostr(strtoint(score4.caption) - 2);


    end;

    if selected = 1 then
    begin
      answerimg1.Picture.LoadFromFile(solutil1.startdir + '\images\wrong.bmp');
      answerimg1.Show;
    end;
    if selected = 2 then
    begin
      answerimg2.Picture.LoadFromFile(solutil1.startdir + '\images\wrong.bmp');
      answerimg2.Show;
    end;
    if selected = 3 then
    begin
      answerimg3.Picture.LoadFromFile(solutil1.startdir + '\images\wrong.bmp');
      answerimg3.Show;
    end;
    if selected = 4 then
    begin
      answerimg4.Picture.LoadFromFile(solutil1.startdir + '\images\wrong.bmp');
      answerimg4.Show;
    end;
  end;

  if correctanswer = 1 then
  begin
    answer1.show; answer2.hide; answer3.Hide; answer4.hide;
  end;
  if correctanswer = 2 then
  begin
    answer1.hide; answer2.show; answer3.Hide; answer4.hide;
  end;
  if correctanswer = 3 then
  begin
    answer1.hide; answer2.hide; answer3.show; answer4.hide;
  end;
  if correctanswer = 4 then
  begin
    answer1.hide; answer2.hide; answer3.Hide; answer4.show;
  end;




end;

procedure TForm2.BitBtn3Click(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TForm2.BitBtn4Click(Sender: TObject);
begin
form3.show;
end;

procedure TForm2.initialize;
begin

end;

procedure TForm2.QuestionDblClick(Sender: TObject);
begin
   form2.BorderStyle := bsnone;
end;

end.

